"""Module that updates the domain model of :term:`GSO`. Should contain all types of subscriptions.

.. warning::
   Whenever a new product type is added, this should be reflected in the :py:class:`gso.products.ProductType`
   enumerator.
"""
from orchestrator.domain import SUBSCRIPTION_MODEL_REGISTRY
from pydantic_forms.types import strEnum

from gso.products.product_types.iptrunk import Iptrunk
from gso.products.product_types.router import Router
from gso.products.product_types.site import Site


class ProductType(strEnum):
    SITE = "Site"
    ROUTER = "Router"
    IP_TRUNK = "IP trunk"


SUBSCRIPTION_MODEL_REGISTRY.update(
    {
        "Site": Site,
        "Router": Router,
        "IP trunk": Iptrunk,
    },
)
