from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from gso.products.product_blocks.router import (
    RouterBlock,
    RouterBlockInactive,
    RouterBlockProvisioning,
)


class RouterInactive(SubscriptionModel, is_base=True):
    router: RouterBlockInactive


class RouterProvisioning(RouterInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    router: RouterBlockProvisioning


class Router(RouterProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    router: RouterBlock
