from orchestrator.services.processes import start_process

from gso.schedules.scheduling import scheduler
from gso.services.subscriptions import count_incomplete_validate_products
from gso.worker import celery


@celery.task
@scheduler(name="Validate Products and inactive subscriptions", minute="30", hour="2")
def validate_products() -> None:
    if count_incomplete_validate_products() > 0:
        start_process("task_validate_products")
